﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Tools.Controls;
using System.Security.Claims;
using System.Collections.ObjectModel;

namespace MultiColumnTreeViewAdvSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ObservableCollection<ComplexObject> _complexObjectCollection = new ObservableCollection<ComplexObject>();

        public MainWindow()
        {
            InitializeComponent();

            // it works when the TreeViewItemAdv collection is defined in the XAML. Comment this code, and uncomment the TreeViewItemAdv definition in the XAML to see
            // the difference
            Init();

            treeViewAdv.Loaded += new RoutedEventHandler(treeViewAdv_Loaded);
        }

        private void Init()
        {
            ComplexObject mainObject1 = new ComplexObject { Name = "Main Object 1", Description = "The main object", IsValid = true };

            ComplexObject childObject1a = new ComplexObject() { Name = "Child object 1a", Description = "Child (1a)", IsValid = true };
            ComplexObject childObject1b = new ComplexObject() { Name = "Child object 1b", Description = "Child (1b)", IsValid = false };

            ObservableCollection<ComplexObject> children = new ObservableCollection<ComplexObject>();
            children.Add(childObject1a);
            children.Add(childObject1b);

            mainObject1.Children = children;

            _complexObjectCollection.Add(mainObject1);

            ComplexObject mainObject2 = new ComplexObject { Name = "Main Object 2", Description = "Another main object", IsValid = true };

            ComplexObject childObject2a = new ComplexObject() { Name = "Child object 2a", Description = "Child (2a)", IsValid = true };
            ComplexObject childObject2b = new ComplexObject() { Name = "Child object 2b", Description = "Child (2b)", IsValid = true };
            ComplexObject childObject2c = new ComplexObject() { Name = "Child object 2c", Description = "Child (2c)", IsValid = false };

            ObservableCollection<ComplexObject> children2 = new ObservableCollection<ComplexObject>();
            children2.Add(childObject2a);
            children2.Add(childObject2b);
            children2.Add(childObject2c);
            mainObject2.Children = children2;

            _complexObjectCollection.Add(mainObject2);

            treeViewAdv.ItemsSource = _complexObjectCollection;
        }

        void treeViewAdv_Loaded(object sender, RoutedEventArgs e)
        {
            FrameworkElementFactory Cell2 = new FrameworkElementFactory(typeof(TextBlock));
            Binding placeBinding2 = new Binding();
            placeBinding2.RelativeSource = new RelativeSource(RelativeSourceMode.FindAncestor, typeof(TreeViewItemAdv), 1);
            placeBinding2.Path = new PropertyPath("DataContext.Description");
            placeBinding2.Mode = BindingMode.OneWay;

            //placeBinding2.Converter = new MyDescriptionConverter();
            Cell2.SetBinding(TextBlock.TextProperty, placeBinding2);
            DataTemplate dataTemplate2 = new DataTemplate();
            dataTemplate2.VisualTree = Cell2;
            (sender as TreeViewAdv).Columns[1].CellTemplate = dataTemplate2;

            FrameworkElementFactory Cell3 = new FrameworkElementFactory(typeof(CheckBox));
            Binding placeBinding3 = new Binding();
            placeBinding3.RelativeSource = new RelativeSource(RelativeSourceMode.FindAncestor, typeof(TreeViewItemAdv), 1);
            placeBinding3.Path = new PropertyPath("DataContext.IsValid");
            placeBinding3.Mode = BindingMode.OneWay;
            Cell3.SetBinding(CheckBox.IsCheckedProperty, placeBinding3);
            DataTemplate dataTemplate3 = new DataTemplate();
            dataTemplate3.VisualTree = Cell3;
            (sender as TreeViewAdv).Columns[2].CellTemplate = dataTemplate3;
        }
    }
}
